#property indicator_chart_window
//---- input parameters

extern color  Clock_Color = Red;
extern string Corner_Placement = "1 is top right 3 is bottom right";
extern int    Corner = 3;
extern int    GeometricalFactor = 3;
extern double LotsPercent = 44.85; // mean 2.0%

string sp_close="Spread&Bar";
string freemargin="Free Margin";
string lotz="Lots";


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){

  ObjectCreate(sp_close, OBJ_LABEL,0, 0, 0);
  ObjectSet(sp_close, OBJPROP_CORNER, Corner);
  ObjectSet(sp_close, OBJPROP_XDISTANCE, 10);
  ObjectSet(sp_close, OBJPROP_YDISTANCE, 2);     
  
  ObjectCreate(freemargin, OBJ_LABEL,0, 0, 0);
  ObjectSet(freemargin, OBJPROP_CORNER, Corner);
  ObjectSet(freemargin, OBJPROP_XDISTANCE, 10);
  ObjectSet(freemargin, OBJPROP_YDISTANCE, 16);   
 
  ObjectCreate(lotz, OBJ_LABEL,0, 0, 0);
  ObjectSet(lotz, OBJPROP_CORNER, Corner);
  ObjectSet(lotz, OBJPROP_XDISTANCE, 10);
  ObjectSet(lotz, OBJPROP_YDISTANCE, 28);   
  
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){

  ObjectDelete(sp_close);
  ObjectDelete(freemargin);
  ObjectDelete(lotz);

  //----
  return(0);
} 

//+-------------------------------------------
int start()
{
  int m,s; 
  //------------------------------------------
  //Time to bar expiry 
  m=Time[0]+Period()*60-CurTime();
  s=m%60;
  m=(m-s)/60;
  int spread=MarketInfo(Symbol(), MODE_SPREAD);

  string _sp="",_m="",_s="";
  if (spread<10) _sp="..";
  else if (spread<100) _sp=".";
  if (m<10) _m="0";
  if (s<10) _s="0";
  
  
  
     double LotSize;
   if(MarketInfo(Symbol(),MODE_MINLOT) == 0.1) int LotsDigit = 1;
   else if(MarketInfo(Symbol(),MODE_MINLOT) == 0.01) LotsDigit = 2;
   double MinLots = NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),LotsDigit);
   double MaxLots = NormalizeDouble(MarketInfo(Symbol(),MODE_MAXLOT),LotsDigit);
   double AcFrMar = NormalizeDouble(AccountFreeMargin(),2);
   
   LotSize = (AcFrMar*(LotsPercent/100))/1000/3;
   
   if(LotSize > MaxLots) LotSize = MaxLots;
   if(LotSize < MinLots) LotSize = MinLots; 
    
  
  double margin_level=AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
//  double lots=0.01*MathSqrt(AccountFreeMargin()/5)*1.48975;
  //Draw objects
  ObjectSetText(sp_close,"Sp:"+DoubleToStr(spread,0)+_sp+" Close:"+_m+DoubleToStr(m,0)+":"+_s+DoubleToStr(s,0),10,"Courier",Clock_Color);
  ObjectSetText(freemargin,"M:"+DoubleToStr(margin_level,2),10,"Courier",Clock_Color);
  ObjectSetText(lotz,"L:"/*+DoubleToStr(lots,2)+" "*/+DoubleToStr(LotSize,2),10,"Courier",Clock_Color);
  
  return(0);
}
///////////------------------------------